/*
 *
 *	XENIX debugger - common definitions
 *
 */



#include <sys/param.h>
#include <sys/dir.h>
#include <sys/reg.h>
#include <sys/a.out.h>
#include "user.h"		/* New user.h added */
#include <sys/mmu.h>
#include <sgtty.h>
#include <stdio.h>
#include "mac.h"
#include "mode.h"


#define VARB	11
#define VARD	13
#define VARE	14
#define VARM	22
#define VARS	28
#define VART	29

#define COREMAGIC 0140000

#define RD	0
#define WT	1
#define NSP	0
#define	ISP	1
#define	DSP	2
#define STAR	4
#define STARCOM 0200
#define DSYM	7
#define ISYM	2
#define ASYM	1
#define NSYM	0
#define ESYM	(-1)
#define BKPTSET	1
#define BKPTEXEC 2
#define	SYMSIZ	100
#define MAXSIG	20

 /* break point is type 3 interupt for 8086 altos */
#define BPT	0xcc
#define FD	0200

/*      ptrace(2) opcodes       */

#define SETTRC  0
#define	RIUSER	1
#define	RDUSER	2
#define	RUREGS	3
#define WIUSER	4
#define	WDUSER	5
#define	WUREGS	6
#define	CONTIN	7
#define	EXIT	8
#define	SINGLE	9

/*      ptrace(2) operands      */

#define SAMEPC  1               /* use current PC for CONTIN */


#define FROFF	((char *)(&(0->u_fps)))		/* start of FP save info */
#define FRLEN	(96)				/* size of FP save info */
#define FRMAX	8				/* number of FP registers */

#define MAXOFF	255
#define MAXPOS	80
#define MAXLIN	128
#define EOR	'\n'
#define TB	'\t'
#define QUOTE	0200
#define STRIP	0177
#define LOBYTE	0377
#define EVEN	-2


/* long to ints and back (puns) */
union {
	INT	I[2];
	L_INT	L;
} itolws;

#define leng(a)		((long)((unsigned)(a)))
#define shorten(a)	((int)(a))
#define itol(a,b)	(itolws.I[0]=(a), itolws.I[1]=(b), itolws.L)



/* result type declarations */
L_INT		inkdot();
SYMPTR		lookupsym();
SYMPTR		symget();
POS		get();
POS		chkget();
POS             getb();
POS             chkgetb();
STRING		exform();
L_INT		round();
BKPTR		scanbkpt();
VOID		fault();

typedef struct sgttyb TTY;
TTY	adbtty, usrtty;
#include <setjmp.h>
jmp_buf erradb;
