#
/*
 *
 *	XENIX 8086 debugger
 *
 */

/*
 * Hans	Feb 5, 1983	M000
 *	- Translated it to C  (from S.R.B. code)
 *	- made it do a little of the segmented stuff.
 * Hans Mar 2, 1983	M001
 *	- Changed args of findsym.
 * Hans Mar 10, 1983	M002
 *	- Made it deal with segmented symbols
 */
#include "defs.h"


MSG		NOCFN;

INT		callpc;
BOOL		localok;
SYMTAB		symbol;

STRING		errflg;


findroutine(cframe)
	L_INT		cframe;
{
	REG INT		narg, inst;
	INT		lastpc, back2, back4;
	int		v;
#define SMALL 1
#define MED   2

	v=0;
	localok=FALSE;
	lastpc=callpc;
	callpc=get(cframe+2, DSP);
#ifdef	DEBUG
	printf("Frame = %x, callpc = %x\n", cframe, callpc);
#endif
	back2=get(leng(callpc-2), ISP);
#ifdef	DEBUG
	printf ("back2 = %x, inst = %x\n", back2, get(leng(callpc-4), ISP));
#endif
	if(((inst=get(leng(callpc-4), ISP))&0xFF00) == 0xE800) /* direct call */
	{
		narg = 0;
		v=SMALL;
	}
	else if((inst&0xF8FF)==0x90FF)			/* indirect call.. */
		narg=0;
	else	/* it may be intermediate model... */
	{
#ifdef SEGSYM
		callpc|=get(cframe+4, DSP)<<16;  /*M002*/
#else
		callpc+=get(cframe+4, DSP)<<4;	
#endif
		back4=get(leng(callpc-4), ISP);
		back2=get(leng(callpc-2), ISP);
		if (((inst=get(leng(callpc-6), ISP))&0xFF00) == 0x9A00)
		{
			narg = 0;
			v=MED;
#ifdef DEBUG
			printf("caller %x seg %x, offset %x\n",
				 callpc, back2, back4);
#endif
		}
		/* indirect is too complicated.  bag it for now */


		else	/* nothing works.  cant find the routine */
		{
			errflg=NOCFN;
			return(0);
		}
	}
	if(findsym( (v==MED)?
#ifdef SEGSYM
			(((long)back2<<16)+back4): /*M002*/
#else
			(((long)back2<<4)+back4):  /*M001*/
#endif
		     (v==SMALL)?(long)(callpc+back2): back2, ISYM) == -1)
	{
		symbol.symc[0] = '?';
		symbol.symc[1] = 0;
		symbol.symv = 0;
	}
	else
		localok=TRUE;
	inst = get(leng(callpc), ISP);
	if(inst == 0xC483)		/* add sp,*n */
		narg+=(get(leng(callpc+2), ISP)&0xFF)/2;
	else if(inst == 0xC481)		/* add sp,#n */
		narg+=get(leng(callpc+2), ISP)/2;
	return(v==MED?(-narg):narg);
}

