#include "machine.h"
/*
 *	XENIX debugger
 *
 *	arw	 7 May 1982	M000
 *		- Added `ip' register.  `pc' is now sum of `cs' & `ip'.
 */

#define MAXCOM	64
#define MAXARG	32
#define LINSIZ	256
TYPE	int		INT;
TYPE	int		VOID;
TYPE	long int	L_INT;
TYPE	float		REAL;
TYPE	double		L_REAL;
TYPE	unsigned	POS;
TYPE	char		BOOL;
TYPE	char		CHAR;
TYPE	char		*STRING;
TYPE	char		MSG[];
TYPE	struct map	MAP;
TYPE	MAP		*MAPPTR;
TYPE	struct symtab	SYMTAB;
TYPE	SYMTAB		*SYMPTR;
TYPE	struct symslave SYMSLAVE;
TYPE	struct bkpt	BKPT;
TYPE	BKPT		*BKPTR;


/* file address maps */
struct map {
	L_INT	b1;
	L_INT	e1;
	L_INT	f1;
	L_INT	b2;
	L_INT	e2;
	L_INT	f2;
	INT	ufd;
};


/*      slave table for symbols
 *
 *      this table has the value and types of the symbols, in the
 *      same order as they appear in the symbol table.  This allows
 *      adb to look up a symbol by value and then seek into the
 *      exe file to get the sym name.  Since the sym records in the
 *      x.out file are variable length we have to store a seek offset.
 */

struct symslave {
	SYMV    valslave;               /* value */
	char    typslave;               /* type */
	char    seekhi;                 /* seek offset hi 8 bits */
	unsigned short   seeklo;        /* seek offset low 16 bits */
};

struct bkpt {
	INT	loc;
	INT	ins;
	INT	count;
	INT	initcnt;
	INT	flag;
	CHAR	comm[MAXCOM];
	BKPT	*nxtbkpt;
};

TYPE	struct reglist	REGLIST;
TYPE	REGLIST		*REGPTR;
struct reglist {
	STRING	rname;
	unsigned int *roffs;
};

unsigned int flag, ip, cs, ds, ss, es, sp, bp, si, di, ax, bx, cx, dx;
unsigned int pc;


char Regchange;                 /* flag indicates user modified regs */
