/*
 *
 *	XENIX debugger
 *
 *	arw	 7 May 1982	M000
 *		- Compute value of pc from `cs' and `ip'
 *  JGL & Hans	19,20 Dec 1982	M001
 *		- Major rewrite for x.out format
 *	arw	 1 Feb 1983	M002
 *		- Adjusted sp in setcor so that user regs. are not
 *		  shown.
 *	arw	 4 Mar 1983	M003
 *		- Corrected computation of `pc'.
 *	Hans	 9 Mar 1983	M004
 *		- re-merged some things for segmented version
 *		  the work was actualy done mid feb
 */

#include "defs.h"

MSG		BADNAM;
MSG		BADMAG;

MAP		txtmap;
MAP		datmap;
SYMSLAVE	*symvec;
INT		wtflag;
INT		fcor;
INT		fsym;
FILE            *symstream;
FILE            *fdopen();
L_INT		maxfile;
L_INT		maxstor;
L_INT		txtsiz;
L_INT		datsiz;
L_INT		datbas;
L_INT		stksiz;
STRING		errflg;
INT		middleflg;
INT		magic;
L_INT		symbas;
L_INT		symnum;
L_INT		entrypt;

INT		argcount;
INT		signo;
POS             corhdr[ptob(USIZE)/sizeof(POS)];
POS		*endhdr = &corhdr[ptob(USIZE)/sizeof(POS)];

STRING		symfil	"a.out";
STRING		corfil	"core";

#define TXTHDRSIZ	(sizeof(txthdr))



/*      setsym - readup the executable image
 */

setsym()
{
	register short i;
	INT		relflg;
	SYMV		symval;		/*M004*/
	INT		symflg;
	SYMSLAVE	*symptr;
	SYMPTR		symp;
	union   {
		struct xexec x;
		struct aexec a;
	} txthdr;

	fsym=getfile(symfil,1);
	if (fsym != -1)
		symstream = fdopen(fsym, wtflag?"r+":"r");
	else
		symstream = 0;
	txtmap.ufd=fsym;
	/* start M001 */
	IF read(fsym, &txthdr, TXTHDRSIZ)==TXTHDRSIZ
	THEN    magic=txthdr.x_magic;
		/* if x.out format */
		IF magic==(X_MAGIC)
		THEN
			txtsiz=txthdr.x.x_text;
			datsiz=txthdr.x.x_data;
			symbas=txtsiz+datsiz;
			txtmap.b1=0;
			txtmap.e1=txtsiz;
			txtmap.f1 = TXTHDRSIZ;
			txtmap.b2=datbas=0;
			txtmap.e2=datsiz;
			txtmap.f2 = TXTHDRSIZ+txtmap.e1;
			entrypt=txthdr.x.x_entry;
			relflg=1;
			middleflg=txthdr.x.x_renv&XE_LTEXT;	/*M004*/
			symbas += TXTHDRSIZ;

			/*      set up symvec
			 *
			 *      We keep the values and types of all symbols
			 *      in core, in the same order as they appear
			 *      in the exe file.  This allows us to do a
			 *      by-value loopup rapidly.  We still have to
			 *      read the exefile to do a by-name lookup.
			 */

			symnum = cntsyms((long)txthdr.x.x_syms);
			symvec=malloc(shorten((1+symnum))*sizeof (SYMSLAVE));
			IF (symptr=symvec)==-1
			THEN	printf("%s\n",BADNAM);
				symptr=symvec=malloc(sizeof (SYMSLAVE));
			ELSE
				long sympos;

				symset();
				WHILE (symp=symget(&sympos)) ANDF errflg==0
				DO  symval=symp->symv; symflg=symp->symf;
				    symptr->valslave=symval;
				    symptr->typslave=SYMTYPE(symflg);
				    sympos += symbas;
				    symptr->seeklo = (unsigned short)sympos;
				    symptr->seekhi = (sympos>>16);
				    symptr++;
				OD
			FI
			symptr->typslave=ESYM;
		/* end M001 */
		ELSE IF magic!=A_MAGIC3 ANDF magic!=A_MAGIC2 ANDF magic!=A_MAGIC1 ANDF magic!=A_MAGIC4
		THEN	magic=0;
		/* old a.out (0407 0411) files */
		ELSE    symnum=txthdr.a.xa_syms/SYMTABSIZ;
			txtsiz=txthdr.a.xa_text;
			datsiz=txthdr.a.xa_data;
			symbas=txtsiz+datsiz;
			txtmap.b1=0;
			txtmap.e1=(magic==A_MAGIC1?symbas:txtsiz);
			txtmap.f1 = sizeof(struct aexec);
			txtmap.b2=datbas=(magic==A_MAGIC2?round(txtsiz,TXTRNDSIZ):0);
			txtmap.e2=txtmap.b2+(magic==A_MAGIC1?symbas:datsiz);
			txtmap.f2 = sizeof(struct aexec)+(magic==A_MAGIC1?0:txtmap.e1);
			entrypt=txthdr.a.xa_entry;
			relflg=txthdr.a.xa_flag;
			IF relflg!=1 THEN symbas =<< 1; FI
			symbas += sizeof(struct aexec);

			/* set up symvec */
			symvec=sbrk(shorten((1+symnum))*sizeof (SYMSLAVE));
			IF (symptr=symvec)==-1
			THEN	printf("%s\n",BADNAM);
				symptr=symvec=sbrk(sizeof (SYMSLAVE));
			ELSE	symset();
				WHILE (symp=symget(0)) ANDF errflg==0
				DO  symval=symp->symv; symflg=symp->symf;
				    symptr->valslave=symval;
				    symptr->typslave=SYMTYPE(symflg);
				    symptr++;
				OD
			FI
			symptr->typslave=ESYM;
		FI
	    FI
	FI
	IF magic==0 THEN txtmap.e1=maxfile; FI
}

setcor()
{
	extern int oldsp;
	int *axptr;

	fcor=getfile(corfil,2);
	datmap.ufd=fcor;
	IF read(fcor, corhdr, ptob(USIZE))==ptob(USIZE)
	THEN	txtsiz = ptob(corhdr->u_tsize);
		datsiz = ptob(corhdr->u_dsize);
		stksiz = ptob(corhdr->u_ssize);
		datmap.b1 = datbas = (magic==A_MAGIC2?round(txtsiz,TXTRNDSIZ):0);
		datmap.e1=(magic==A_MAGIC1?txtsiz:datmap.b1)+datsiz;
		datmap.f1 = ptob(USIZE);
		datmap.b2 = maxstor-stksiz;
		datmap.e2 = maxstor;
		datmap.f2 = ptob(USIZE)+(magic==A_MAGIC2?datsiz:datmap.e1);

		/* fetch registers from corefile into local cells */
		/* read user regs in u_ area */
		axptr = (unsigned)corhdr +
			((unsigned)corhdr->u_aAX & OFFMASK);
		ax = axptr[RAX];
		bx = axptr[RBX];
		cx = axptr[RCX];
		di = axptr[RDI];
		si = axptr[RSI];
		ds = axptr[RDS];
		ss = axptr[RSS];
		sp = axptr[RSP];
		/* now, the regs that are on the user stack */
		dx = get((L_INT)(sp+URDX), DSP);
		es = get((L_INT)(sp+URES), DSP);
		bp = get((L_INT)(sp+URBP), DSP);
		ip = get((L_INT)(sp+URIP), DSP);		/* M000 */
		cs = get((L_INT)(sp+URCS), DSP);
		pc = ((cs-SEGUI) << 4) + ip;			/* M003 */
		flag = get((L_INT)(sp+URFLAG), DSP);
		oldsp = sp;					/* M002 */
		sp += URBC;					/* M002 */

		IF magic ANDF (X_MAGIC) != corhdr[0].u_exdata.x_magic
		THEN	printf("%s\n",BADMAG);
		FI
	ELSE	datmap.e1 = maxfile;
	FI
}

create(f)
STRING	f;
{	int fd;
	IF (fd=creat(f,0644))>=0
	THEN close(fd); return(open(f,wtflag));
	ELSE return(-1);
	FI
}

getfile(filnam,cnt)
STRING	filnam;
{
	REG INT		fsym;

	IF !eqstr("-",filnam)
	THEN	fsym=open(filnam,wtflag);
		IF fsym<0 ANDF argcount>cnt
		THEN	IF wtflag
			THEN	fsym=create(filnam);
			FI
			IF fsym<0
			THEN printf("cannot open `%s'\n", filnam);
			FI
		FI
	ELSE	fsym = -1;
	FI
	return(fsym);
}
